<?php
/**
 * copyright (c) 2006-2010 JTL-Software-GmbH, all rights reserved
 *
 * this file may not be redistributed in whole or significant part
 * and is subject to the JTL-Software-GmbH license.
 *
 * license: http://jtl-software.de/jtlshop3license.html
 */

require_once('../globalinclude.php');
require_once('class.JTL-Shop.UploadDatei.php');


/**
 * output
 *
 * @param int $bOk
 */
function retCode($bOk)
{
    die($bOk ? '1' : '0');
}

// session
if (!isset($_REQUEST['sid'])) {
    retCode(0);
}

$_COOKIE['JTLSHOP'] = $_REQUEST['sid'];
if (method_exists('Session', 'getInstance')) {
    $session = Session::getInstance();
} else {
    $session = new Session();
}
// upload file
if (!empty($_FILES)) {
    if (!isset($_REQUEST['uniquename'])) {
        retCode(0);
    }
    $cUnique     = $_REQUEST['uniquename'];
    $cTargetFile = PFAD_UPLOADS . $cUnique;
    $fileData    = isset($_FILES['Filedata']['tmp_name'])
        ? $_FILES['Filedata']
        : $_FILES['file_data'];
    $cTempFile   = $fileData['tmp_name'];
    $info        = pathinfo($cTargetFile);
    $realPath    = realpath($info['dirname']);
    if (isset($fileData['error'])
        && (int)$fileData['error'] === 0
        && (!isset($info['extension'])
            || !in_array($info['extension'], array('php', 'php4', 'php5', 'htaccess', 'ini', 'conf', 'load'), true))
        && strpos($realPath . '/', PFAD_UPLOADS) === 0
        && !file_exists($cTargetFile)
        && move_uploaded_file($cTempFile, $cTargetFile)
    ) {
        $oFile         = new stdClass();
        $oFile->cName  = $_FILES['Filedata']['name'];
        $oFile->nBytes = $_FILES['Filedata']['size'];

        if (!isset($_SESSION['Uploader'])) {
            $_SESSION['Uploader'] = array();
        }
        $_SESSION['Uploader'][$cUnique] = $oFile;
        retCode(1);
    } else {
        retCode(0);
    }
}

// handle file
if (!empty($_REQUEST['action'])) {
    switch ($_REQUEST['action']) {
        case 'remove':
            $cUnique   = $_REQUEST['uniquename'];
            $cFilePath = PFAD_UPLOADS . $cUnique;
            $info      = pathinfo($cFilePath);
            $realPath  = realpath($info['dirname']);
            if ($info['extension'] !== 'htaccess'
                && isset($_SESSION['Uploader'][$cUnique])
                && strpos($realPath . '/', PFAD_UPLOADS) === 0
            ) {
                unset($_SESSION['Uploader'][$cUnique]);
                if (file_exists($cFilePath)) {
                    retCode(@unlink($cFilePath));
                }
            } else {
                retCode(0);
            }
            break;

        case 'exists':
            $cFilePath = PFAD_UPLOADS . $_REQUEST['uniquename'];
            retCode(file_exists(realpath($cFilePath)));
            break;

        case 'preview':
            $oUpload   = new UploadDatei();
            $kKunde    = (int)$_SESSION['Kunde']->kKunde;
            $cFilePath = PFAD_ROOT . BILD_UPLOAD_ZUGRIFF_VERWEIGERT;
            $kUpload   = (int)entschluesselXTEA(rawurldecode($_REQUEST['secret']));

            if ($kUpload > 0 && $kKunde > 0 && $oUpload->loadFromDB($kUpload)) {
                $cTmpFilePath = PFAD_UPLOADS . $oUpload->cPfad;
                if (file_exists($cTmpFilePath)) {
                    $cFilePath = $cTmpFilePath;
                }
            }
            header('Cache-Control: max-age=3600, public');
            header('Content-type: Image');

            readfile($cFilePath);
            exit;

        default:
            break;
    }
}

retCode(0);
?>